program CommisVoyageur;

uses Windows, messages, graphics, sysutils, unit1, math;
  
{$R CommisVoyageur.res}

function GetOpenFileName(var OpenFile: tagOFNA): Bool; stdcall; external 'comdlg32.dll' name 'GetOpenFileNameA';
function GetSaveFileName(var OpenFile: tagOFNA): Bool; stdcall; external 'comdlg32.dll' name 'GetSaveFileNameA';

var
  z:integer;
  MainWND: thandle;
  hFontBold: THandle;
  WC: TWndClass;
  Mesg: TMsg;
  but1,but2,but3,but4,ed1,ed3,l1,l2,l3,l4: THandle;
  sour: tbitmap; //,  
  ps: array of PARGB;  //      
  grt: trect;   // Graphic RecT
  Thr: longword;
  ofn: tagOFNA;
  oFilterIndex: DWORD;
  Sum:extended; //   

procedure CalcProc;
 var i,j,p,t,k:integer;
 ar1,ar2,pr1,pr2:inar;
 x,y:extended;
 trig:boolean;
begin
 Sum:=0;
 MinL:=0;
 pr1:=nil; //   
 setlength(Ind,N); //       
 for i:=0 to N-1 do Ind[i]:=i;
 queryperformancecounter(t1);
 if N>1 then begin
  if ProSolver(0,N-1) then begin //   !
   setlength(ar1,maxN+1);
   Setlength(ar2,1);  
   pr1:=ar1;
   for j:=0 to MaxN-1 do ar1[j+1]:=CS2[j];
   trig:=true;
   repeat
    if trig then begin
     pr1:=ar1;
     pr2:=ar2;
    end else begin
     pr2:=ar1;
     pr1:=ar2;
    end;
    setlength(pr2,1); //   ,   
    t:=(length(pr1)-1) div maxN; //  ,    (   )
    for k:=0 to t-1 do 
     for i:=1 to maxN-1 do
      if ProSolver(pr1[i+maxN*k],pr1[i+1+maxN*k]) then begin  //    
       p:=high(pr2)+1;
       setlength(pr2,length(pr2)+MaxN); //   ,       CS
       for j:=0 to MaxN-1 do pr2[p+j]:=CS2[j]; //     MaxN
      end;
    trig:=not(trig);  // 
   until length(pr2)=1;
  end;   
 end;
 for i:=0 to N-2 do begin      //  ,         ,   ...
  x:=mas[Ind[i]].x-mas[Ind[i+1]].x;
  y:=mas[Ind[i]].y-mas[Ind[i+1]].y;
  sum:=sum+sqrt(x*x+y*y);    
 end;
 queryperformancecounter(t2);
 sendmessage(mainwnd,MY_MES,0,0);
end;

function GetCaption(wnd:Thandle):string;
begin
 setlength(result,255);
 setlength(result,getwindowtext(wnd,pchar(result),255));
end;

procedure bres_circle(xc,yc,radius:integer; r,g,b:byte); // Bresenham's (Pitteway and van Aken) algorithm
 var a,c,d:integer;
 procedure sim(x,y:integer; r,g,b:byte);
  var i,j:integer;
 begin
  i:=xc+x;
  j:=yc+y;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  j:=yc-y;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  i:=xc-x;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  j:=yc+y;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  i:=xc+y;
  j:=yc+x;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  j:=yc-x;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  i:=xc-y;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  i:=xc-y;
  j:=yc+x;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
 end;
begin
 a:=0;
 c:=radius;
 d:=3-2*c;
 while(a<=c) do begin
  sim(a,c,r,g,b);
  if d<0 then d:=d+4*a+8
  else begin
   d:=d+4*(a-c)+10;
   dec(c);
  end;
  inc(a)
 end;
end;

procedure SetPoint(j,i: integer; r,g,b:byte);
begin
 ps[j,i].r:=r;
 ps[j,i].g:=g;
 ps[j,i].b:=b;
end;

procedure DrawNodes;
 var i:integer;
 d1:hdc;
begin
 sour.Canvas.FillRect(grt);
 for i:=0 to N-1 do begin
  bres_circle(mas[i].i,mas[i].j,radius,0,0,0);
 end;
 bres_circle(mas[0].i,mas[0].j,radius-1,255,0,0);   //  ( 0)            
 bres_circle(mas[0].i,mas[0].j,radius-2,255,0,0);
 bres_circle(mas[0].i,mas[0].j,radius-3,255,0,0);
 bres_circle(mas[N-1].i,mas[N-1].j,radius-1,0,0,255); //    
 bres_circle(mas[N-1].i,mas[N-1].j,radius-2,0,0,255);
 bres_circle(mas[N-1].i,mas[N-1].j,radius-3,0,0,255);
 setpoint(mas[0].j+1,mas[0].i+1,255,0,0);
 setpoint(mas[0].j-1,mas[0].i+1,255,0,0);
 setpoint(mas[0].j+1,mas[0].i-1,255,0,0);
 setpoint(mas[0].j-1,mas[0].i-1,255,0,0);
 setpoint(mas[N-1].j+1,mas[N-1].i+1,0,0,255);
 setpoint(mas[N-1].j-1,mas[N-1].i+1,0,0,255);
 setpoint(mas[N-1].j+1,mas[N-1].i-1,0,0,255);
 setpoint(mas[N-1].j-1,mas[N-1].i-1,0,0,255);
 d1:=getdc(mainwnd);
 bitblt(d1,9,102,sour.Width,sour.Height,sour.Canvas.Handle,0,0,srccopy); //  
 releasedc(mainwnd,d1);
end;

function Doedin(x:extended):integer; //,  
begin
 if trunc(frac(x)*10)>4 then result:=trunc(x)+1 else result:=trunc(x);
end;

procedure OpenFil;
 var s,FileBuf,filename:string;
     i:integer;
     f:TextFile;
begin
 FileBuf:=StringOfChar(#0, 26000);
 ofn.hWndOwner:=MainWnd;
 ofn.lpstrFilter:='Two-dimensional array (*.txt)'+#0+'*.txt'+#0+#0;;
 ofn.nFilterIndex:=oFilterIndex;
 ofn.lpstrFile:=PChar(FileBuf);
 ofn.nMaxFile:=Length(FileBuf);
 ofn.lpstrInitialDir:=nil;
 ofn.lpstrTitle:='Load two-dimensional array';
 ofn.Flags:=OFN_EXPLORER or OFN_HIDEREADONLY or OFN_NONETWORKBUTTON;
 ofn.lStructSize:=SizeOf(ofn);
 if GetOpenFileName(ofn) then begin
  filename:=ofn.lpstrFile;
  AssignFile(f, FileName);
  Reset(f);
  mas:=nil;
  s:='';
  N:=0;
  try
   while eof(f)=false do begin
    readln(f,s);
    if s<>'' then begin
     inc(N);
     setlength(mas,N);
     i:=pos(' ',s);
     mas[N-1].x:=strtofloat(copy(s,1,i));
     mas[N-1].y:=strtofloat(copy(s,i+1,length(s)-i));
     mas[N-1].i:=doedin(mas[N-1].x*sour.Width);
     mas[N-1].j:=doedin(mas[N-1].y*sour.Width);
    end;
   end;
  finally
   CloseFile(f);
  end;
  if mas<>nil then begin
   DrawNodes;
   enablewindow(but2,true);  //   
   enablewindow(but3,true);
   setwindowtext(l2,'Factual time: 0 sec');
   setwindowtext(l3,'Best distance: 0');
   SetWindowText(ed3,pchar(inttostr(N)));
  end;
 end;
end;

procedure SaveFil;
 var s,filname,FileBuf:string;
 i:integer;
 f:TextFile;
begin
 FileBuf:=StringOfChar(#0, 26000);
 ofn.hWndOwner:=MainWnd;
 ofn.lpstrFilter:='Two-dimensional array (*.txt)'+#0+'*.txt'+#0+#0;;
 ofn.nFilterIndex:=oFilterIndex;
 ofn.lpstrFile:=PChar(FileBuf);
 ofn.nMaxFile:=Length(FileBuf);
 ofn.lpstrInitialDir:=nil;
 ofn.lpstrTitle:='Save two-dimensional array';
 ofn.Flags:=OFN_EXPLORER or OFN_HIDEREADONLY or OFN_NONETWORKBUTTON;
 ofn.lStructSize:=SizeOf(ofn);
 if GetSaveFileName(ofn) then begin
  filname:=ChangeFileExt(ofn.lpstrFile,'')+'.txt';
  AssignFile(f,filname);
  Rewrite(f);
  try
   for i:=0 to N-1 do begin
    s:=floattostr(mas[i].x)+' '+floattostr(mas[i].y);
    WriteLn(f,s);
   end;
  finally
   CloseFile(f);
  end;
 end;
end;

procedure Generate;
 var i:integer;
 s:string;
begin
 s:=GetCaption(ed3);
 if s='' then begin messagebox(mainwnd,'     Enter a valid quantity.','Error!',mb_ok or mb_iconerror); exit; end;
 N:=strtoint(s);
 if N=0  then begin messagebox(mainwnd,'     Enter a valid quantity.','Error!',mb_ok or mb_iconerror); exit; end;
 setlength(mas,N);
 randomize;
 for i:=0 to N-1 do begin
  mas[i].x:=doedin(1000000*(radius*2/sour.Width+(random*(sour.Width-radius*4)/sour.Width)))/1000000;
  mas[i].y:=doedin(1000000*(radius*2/sour.Width+(random*(sour.Width-radius*4)/sour.Width)))/1000000;
  mas[i].i:=doedin(mas[i].x*sour.Width);
  mas[i].j:=doedin(mas[i].y*sour.Width);
 end;
 DrawNodes;
 enablewindow(but2,true);      //   
 enablewindow(but3,true);
 setwindowtext(l2,'Factual time: 0 sec');
 setwindowtext(l3,'Best distance: 0');
end;

function WindowProc(Wnd:HWND; Msg:Integer; wParam:wParam; lParam:lParam):Longint; stdcall;
 var PST:PAINTSTRUCT;
     d1:hdc;
     i:integer;
     s:string;
begin
  Result:=0;
  case Msg of
   WM_COMMAND:if HIWORD(wParam)=BN_CLICKED then begin
     if cardinal(lparam)=but1 then OpenFil;  // Load

     if cardinal(lparam)=but2 then SaveFil;  // Save

     if cardinal(lparam)=but3 then begin     // SOLVE
      s:=GetCaption(ed1);
      if strtoint(s)<3 then begin messagebox(mainwnd,' Enter a valid number of groups.','Error!',mb_ok or mb_iconerror); exit; end;
      MaxN:=strtoint(s);
      enablewindow(but1,false);
      enablewindow(but2,false);
      enablewindow(but3,false);
      enablewindow(but4,false);
      enablewindow(ed1,false);
      enablewindow(ed3,false);
      setwindowtext(mainwnd,' Commis Voyageur - executing, please wait...');
      setwindowtext(l2,'Factual time: executing...');
      setwindowtext(l3,'Best distance: executing...');
      CreateThread(nil,0,@CalcProc,nil,0,Thr);  //  
      SetThreadPriority(Thr,THREAD_PRIORITY_TIME_CRITICAL); // ,     
     end;

     if cardinal(lparam)=but4 then Generate;       // generate

   end else Result:=DefWindowProc(Wnd, Msg, wParam, lParam);

   WM_CREATE: begin
    But1:=CreateWindow('BUTTON', 'Load', WS_CHILD
     or WS_VISIBLE or BS_PUSHLIKE,b1x,b1y,b1w,b1h,Wnd,0,hInstance,nil);
    SendMessage(But1,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    But2:=CreateWindow('BUTTON','Save',WS_CHILD or WS_DISABLED
     or WS_VISIBLE or BS_PUSHLIKE,b2x,b2y,b2w,b2h,Wnd,0,hInstance,nil);
    SendMessage(But2,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    But3:=CreateWindow('BUTTON','SOLVE',WS_CHILD or WS_DISABLED
     or WS_VISIBLE or BS_PUSHLIKE,b3x,b3y,b3w,b3h,Wnd,0,hInstance,nil);
    SendMessage(But3,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    But4:=CreateWindow('BUTTON','Generate',WS_CHILD
     or WS_VISIBLE or BS_PUSHLIKE,b4x,b4y,b4w,b4h,Wnd,0,hInstance,nil);
    SendMessage(But4,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    ed1:=CreateWindow('EDIT','13',WS_CHILD or ES_NUMBER        //  
     or WS_VISIBLE,e1x,e1y,e1w,e1h,Wnd,0,hInstance,nil);
    SendMessage(ed1,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    ed3:=CreateWindow('EDIT','100',WS_CHILD or ES_NUMBER         //  
     or WS_VISIBLE,e3x,e3y,e3w,e3h,Wnd,0,hInstance,nil);
    SendMessage(ed3,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    l1:=CreateWindow('STATIC','Groups = ',WS_CHILD or SS_LEFT
     or WS_VISIBLE,l1x,l1y,l1w,l1h,Wnd,0,hInstance,nil);
    SendMessage(l1,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    l2:=CreateWindow('STATIC','Factual time: 0 sec',WS_CHILD or SS_LEFT
     or WS_VISIBLE,l2x,l2y,l2w,l2h,Wnd,0,hInstance,nil);
    SendMessage(l2,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    l3:=CreateWindow('STATIC','Best distance: 0',WS_CHILD or SS_LEFT
     or WS_VISIBLE,l3x,l3y,l3w,l3h,Wnd,0,hInstance,nil);
    SendMessage(l3,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    l4:=CreateWindow('STATIC','Nodes =',WS_CHILD or SS_LEFT
     or WS_VISIBLE,l4x,l4y,l4w,l4h,Wnd,0,hInstance,nil);
    SendMessage(l4,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    SetFocus(But1);
    result:=0;
   end;

   WM_DESTROY:begin
    DeleteObject(hFontBold);
    unregisterclass('CommVoyagKlass',hinstance);
    postquitmessage(0);
   end;

   WM_PAINT: begin
    BeginPaint(wnd,pst);
    d1:=getdc(mainwnd);
    bitblt(d1,9,102,sour.Width,sour.Height,sour.Canvas.Handle,0,0,srccopy);
    releasedc(mainwnd,d1);
    Endpaint(wnd,pst);
    result:=0;
   end;

   MY_MES: begin
    setwindowtext(l2,pchar('Factual time: '+floattostr((t2-t1)/t3)+' sec')); // ,  
    setwindowtext(l3,pchar('Best distance: '+floattostr(Sum)));
    DrawNodes;
    for i:=0 to N-2 do begin
     sour.Canvas.MoveTo(mas[Ind[i]].i, mas[Ind[i]].j);
     sour.Canvas.LineTo(mas[Ind[i+1]].i, mas[Ind[i+1]].j);
    end;
    sendmessage(mainwnd,WM_PAINT,0,0);
    enablewindow(but1,true);
    enablewindow(but2,true);
    enablewindow(but3,true);
    enablewindow(but4,true);
    enablewindow(ed3,true);
    enablewindow(ed1,true);
    setwindowtext(mainwnd,' Commis Voyageur');
   end;
  else
   Result:=DefWindowProc(Wnd, Msg, wParam, lParam);
  end;
end;

BEGIN
 queryperformancefrequency(t3);

 hFontBold:=CreateFont(8,0,0,0,0,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,
            CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,0,'MS Sans Serif');
 WC.lpfnWndProc:=@WindowProc;
 WC.hicon:=loadicon(hinstance,'MAINICON');
 WC.hCursor:=LoadCursor(0,idc_arrow);
 WC.hbrBackground:=5;
 WC.lpszClassName:='CommVoyagKlass';
 RegisterClass(WC);
 systemparametersinfo(spi_getworkarea, 0, @grt, 0);
 MainWND:=CreateWindow('CommVoyagKlass',' Commis Voyageur',WS_VISIBLE or WS_SYSMENU or WS_MINIMIZEBOX,
       (grt.Right-grt.Left-535) div 2,(grt.Bottom-grt.Top-424) div 2,424,535,0,0,hInstance, nil);

 sour:=tbitmap.Create;
 sour.PixelFormat:=pf24bit;
 sour.Width:=400;
 sour.Height:=400;
 setlength(ps,sour.Height);  //     
 for z:=0 to High(ps) do ps[z]:=sour.scanline[z];

 While GetMessage(Mesg,0,0,0) do begin
  TranslateMessage(Mesg);
  DispatchMessage(Mesg);
 end;
END.
