unit Unit1;

interface

uses windows, math;

const OFN_EXPLORER = $00080000;
      OFN_NONETWORKBUTTON = $00020000;
      OFN_HIDEREADONLY = $00000004;
      //    
      b1x=9;     e1x=358;      l1x=308;
      b1y=7;     e1y=9;        l1y=10;
      b1w=55;    e1w=51;       l1w=48;
      b1h=25;    e1h=15;       l1h=15;

      b2x=9;                   l2x=72;
      b2y=38;                  l2y=60;
      b2w=55;                  l2w=220;
      b2h=25;                  l2h=15;

      b3x=9;     e3x=180;      l3x=72;
      b3y=69;    e3y=9;        l3y=81;
      b3w=55;    e3w=81;       l3w=240;
      b3h=25;    e3h=15;       l3h=15;

      b4x=72;                  l4x=133;
      b4y=7;                   l4y=10;
      b4w=55;                  l4w=45;
      b4h=25;                  l4h=15;

      radius = 3; // 
      MY_MES = $8008;

type
 node = record
  x,y:extended;
  i,j:cardinal; // x y  
 end;

 trgb = record  //     ,     
  b,g,r: byte;
 end;
 ARGB = array [0..399] of TRGB;
 PARGB = ^ARGB;
 
 inar = array of integer;

 tagOFNA = packed record
  lStructSize: DWORD;
  hWndOwner: HWND;
  hInstance: HINST;
  lpstrFilter: PAnsiChar;
  lpstrCustomFilter: PAnsiChar;
  nMaxCustFilter: DWORD;
  nFilterIndex: DWORD;
  lpstrFile: PAnsiChar;
  nMaxFile: DWORD;
  lpstrFileTitle: PAnsiChar;
  nMaxFileTitle: DWORD;
  lpstrInitialDir: PAnsiChar;
  lpstrTitle: PAnsiChar;
  Flags: DWORD;
  nFileOffset: Word;
  nFileExtension: Word;
  lpstrDefExt: PAnsiChar;
  lCustData: LPARAM;
  lpfnHook: function(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): UINT stdcall;
  lpTemplateName: PAnsiChar;
 end;

var
  mas: array of node;  //   
  N:integer;           //     
  Vhod: inar;          // ,    
  minL: extended;      //      
  t1,t2,t3:int64;
  MaxN,BenchN:integer; //   (  )        
  CS,CS2: inar;        // /   
  Ind: inar;           // /  ,        
  PPS:integer;         // -    Vhod
  Mpar:inar;           //   ,       

function ProSolver(vh,vih:integer):boolean;

implementation

procedure MakeTsentrs(vh,vih,m:integer); // m    Ind   vh   vih
 var i,j,l,k:integer;
 max,min,z,x1,y1:extended;
begin
 setlength(CS,m); //     
 CS[0]:=Ind[vh];    //        -   ,     ,        
 CS[1]:=Ind[vih];
 k:=1; //    
 repeat   //        
  max:=0;
  l:=-1;
  for i:=vh+1 to vih-1 do begin  //    ,  
   if Ind[i]=-1 then continue; //      -   
   min:=infinity; //      
   for j:=0 to k do begin
    x1:=mas[Ind[i]].x-mas[CS[j]].x;  //       
    y1:=mas[Ind[i]].y-mas[CS[j]].y;
    z:=sqrt(x1*x1+y1*y1);         
    if z<min then min:=z;
   end;
   if min>max then begin //     
    max:=min;
    l:=i;
   end;
  end;
  inc(k);
  CS[k]:=Ind[l];//  . CS    Ind, ..   mas
  Ind[l]:=-1; //  !   
 until k=m-1;
 CS[1]:=CS[k]; //     ,     (/)  
 CS[k]:=Ind[vih]; //            !!!!
end;

procedure Combi(Arc: array of integer; Len: extended; K, B, V:integer);  //B -      Arc
 var Ac:array of integer;                                                // V -    Ind
 l: extended;                                                                
 i,z,j: integer;
 trig: boolean;
 x1,y1,x2,y2,x3,y3,x4,y4: extended; 
begin
 if K=PPS then begin   //K -  ,   -    Arc 1      3
  x1:=mas[Vhod[K]].x-mas[Arc[0]].x;  //       (     ,    )
  y1:=mas[Vhod[K]].y-mas[Arc[0]].y;
  x2:=mas[Arc[0]].x-mas[Vhod[K+2]].x;
  y2:=mas[Arc[0]].y-mas[Vhod[K+2]].y;
  l:=sqrt(x1*x1+y1*y1)+sqrt(x2*x2+y2*y2);
  if (l+Len)<minL then begin
   minL:=l+len;
   for i:=1 to K do Mpar[i+V]:=Vhod[i]; //        / 
   Mpar[K+1+V]:=Arc[0];
  end;   //   ,    
 end else begin  //       
  setlength(Ac,B); //        1
  for i:=0 to B-1 do Ac[i]:=Arc[i]; //     
  z:=Arc[B]; //       
  i:=-1;
  while true do begin
   x1:=mas[Vhod[K]].x-mas[z].x;
   y1:=mas[Vhod[K]].y-mas[z].y;
   l:=len+sqrt(x1*x1+y1*y1);// 
   if l<MinL then begin //       -    
    trig:=true;
    for j:=0 to K-1 do begin
     x1:=mas[Vhod[j]].x;    // 
     y1:=mas[Vhod[j]].y;
     x2:=mas[Vhod[j+1]].x;
     y2:=mas[Vhod[j+1]].y;
     x3:=mas[Vhod[K]].x;    // 
     y3:=mas[Vhod[K]].y;
     x4:=mas[z].x;
     y4:=mas[z].y;
     if (((x4-x3)*(y1-y3)-(y4-y3)*(x1-x3))*((x4-x3)*(y2-y3)-(y4-y3)*(x2-x3))<0) and    // 
        (((x2-x1)*(y3-y1)-(y2-y1)*(x3-x1))*((x2-x1)*(y4-y1)-(y2-y1)*(x4-x1))<0) then begin
      trig:=false;
      break;
     end;
    end;
    if trig then begin //         
     j:=K+1;
     Vhod[j]:=z; //       
     Combi(Ac,l,j,B-1,V);  //     
    end;
   end;
   inc(i);
   if i>(B-1) then break;
   j:=Ac[i];
   Ac[i]:=z;
   z:=j;
  end;
 end;
end;

function GetUgol(x1,y1,x2,y2,x3,y3:extended):extended;   //      0 (0 )  1 (180 )
 var dx1,dy1,dx2,dy2:extended;
begin
 dx1:=x1-x2;
 dx2:=x3-x2;
 dy1:=y1-y2;
 dy2:=y3-y2;
 result:=arccos((dx1*dx2+dy1*dy2)/sqrt((dx1*dx1+dy1*dy1)*(dx2*dx2+dy2*dy2)));
end;

function ProSolver(vh,vih:integer):boolean;//  -  ,    Ind
 var i,j,N1,t,lp:integer;
 x1,x2,y1,y2,min,l,l2:extended;    
 Ac:array of integer;
 NewArcs: array of array of integer;
 Groups:array of array of integer;
begin
 N1:=vih-vh+1; //    Ind
 if N1<4 then begin result:=false; exit; end; //  2  3   
 if N1<=MaxN then begin //      ,     
  t:=N1-3; //   
  setlength(Vhod,N1); //         ( ,    )
  Vhod[0]:=Ind[vh];   // (!)  Ind ..   mas
  Vhod[N1-1]:=Ind[vih];
  setlength(Ac,N1-2); //        vh  vih
  for i:=0 to t do Ac[i]:=Ind[i+vh+1]; 
  minL:=infinity;
  PPS:=t;
  Mpar:=Ind;
  Combi(Ac,0,0,t,Vh);  //         
  result:=false;
 end else begin    //     -   
   //      / -   ,   -  .
   //          ,    ...
   // ,   20 ,     14 . ,   ,   .
   // ..   "   "  "  ".
  MakeTsentrs(vh,vih,MaxN);
  if MaxN>3 then begin //  4-     2  3    
   t:=MaxN-3; //   
   setlength(Vhod,MaxN); //         ( ,    )
   Vhod[0]:=CS[0]; //   CS  ..   mas
   Vhod[MaxN-1]:=CS[MaxN-1];
   setlength(Ac,MaxN-2);
   for i:=0 to t do Ac[i]:=CS[i+1];
   minL:=infinity;
   PPS:=t;
   Mpar:=CS;
   Combi(Ac,0,0,t,0);  //         
  end;

  Setlength(Groups,MaxN); //     
  for i:=vh+1 to vih-1 do begin
   if Ind[i]=-1 then continue; //   ,   
   min:=infinity;
   lp:=-1;
   for j:=0 to MaxN-1 do begin   //  
    x1:=mas[Ind[i]].x-mas[cs[j]].x;
    y1:=mas[Ind[i]].y-mas[cs[j]].y;
    l:=sqrt(x1*x1+y1*y1); //   
    if l<min then begin
     min:=l;
     lp:=j;
    end;
   end;
   setlength(Groups[lp],length(Groups[lp])+1); //lp -    
   Groups[lp][high(Groups[lp])]:=Ind[i]; //  , ..    mas
  end;

  t:=MaxN-2; //   
  setlength(NewArcs,MaxN-1); //    ,   

  setlength(NewArcs[0],length(Groups[0])); //  
  for i:=0 to high(Groups[0]) do NewArcs[0][i]:=Groups[0][i];

  setlength(NewArcs[t],length(Groups[MaxN-1]));
  for i:=0 to high(Groups[MaxN-1]) do NewArcs[t][i]:=Groups[MaxN-1][i];

  for i:=1 to high(Groups)-1 do   //     
   for j:=0 to high(Groups[i]) do begin
    x1:=mas[Groups[i][j]].x-mas[cs[i-1]].x;
    y1:=mas[Groups[i][j]].y-mas[cs[i-1]].y;
    l:=sqrt(x1*x1+y1*y1)/GetUgol(mas[cs[i-1]].x,mas[cs[i-1]].y,mas[Groups[i][j]].x,mas[Groups[i][j]].y,mas[cs[i]].x,mas[cs[i]].y);
    x2:=mas[Groups[i][j]].x-mas[cs[i+1]].x;
    y2:=mas[Groups[i][j]].y-mas[cs[i+1]].y;
    l2:=sqrt(x2*x2+y2*y2)/GetUgol(mas[cs[i]].x,mas[cs[i]].y,mas[Groups[i][j]].x,mas[Groups[i][j]].y,mas[cs[i+1]].x,mas[cs[i+1]].y);
    if l<l2 then lp:=i-1 else lp:=i;
    setlength(NewArcs[lp],length(NewArcs[lp])+1); //lp -    
    NewArcs[lp][high(NewArcs[lp])]:=Groups[i][j];
   end;

  setlength(CS2,MaxN); //  ,     Ind
  CS2[0]:=Vh;
  CS2[MaxN-1]:=Vih;
  lp:=vh;
  for i:=0 to t do begin         //     Ind,   
   for j:=0 to high(NewArcs[i]) do begin
    inc(lp);
    Ind[lp]:=NewArcs[i][j];
   end;
   inc(lp);
   Ind[lp]:=CS[i+1]; //     
   CS2[i+1]:=lp;
  end;

  result:=true;    
 end;    
end;

end.
